{
  

}

unit MainMp3;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Buttons, ComCtrls, ExtCtrls, StdCtrls ,uplaylist, Menus,
  rkGlassButton, rkVistaProBar, jpeg ,UDisegniForm, EkImgForm, EkImgTrackBar,
  EkImgFadeBase, EkImgBtn, EkImgProgressBar;

type

  TMainForm = class(TForm)
    SpeedButton2: TSpeedButton;
    Timer1: TTimer;
    TrayIcon1: TTrayIcon;
    OpenDialog1: TOpenDialog;
    Lista: TComboBox;
    LabelBrani: TLabel;
    Label2: TLabel;
    TrayIconMen: TPopupMenu;
    Esci1: TMenuItem;
    Esci2: TMenuItem;
    rkGlassButton1: TrkGlassButton;
    Label3: TLabel;
    Image1: TImage;
    Panel1: TPanel;
    Image2: TImage;
    TrackBar1: TEkImgTrackBar;
    Play: TEkImgBtn;
    Pausa: TEkImgBtn;
    Stop: TEkImgBtn;
    Vol: TEkImgBtn;
    EkImgForm1: TEkImgForm;
    EkImgBtn1: TEkImgBtn;
    Progressbar1: TEkImgTrackBar;
    procedure FormCreate(Sender: TObject);
    procedure PlayClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure VolClick(Sender: TObject);
    procedure PausaClick(Sender: TObject);
    procedure StopClick(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure ListaChange(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Esci2Click(Sender: TObject);
    procedure TrayIcon1DblClick(Sender: TObject);
    procedure LabelBraniMouseEnter(Sender: TObject);
    procedure LabelBraniMouseLeave(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Label3MouseEnter(Sender: TObject);
    procedure Label3MouseLeave(Sender: TObject);
    procedure Label3DblClick(Sender: TObject);
    procedure rkGlassButton1Click(Sender: TObject);
    procedure Esci1Click(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure EkImgBtn1Click(Sender: TObject);
    procedure TrackBar1MouseLeave(Sender: TObject);
    procedure ListaClick(Sender: TObject);
    procedure Progressbar1Change(Sender: TObject);
  private
    Down,
    Resume  : Boolean;
    Tempo   : Cardinal;
    Minuti,
    Ore     : Cardinal;
    StringaLun : String;
    PCartella  : String;
    procedure OnDroppedFiles( var Msg : TMessage ); message WM_DROPFILES;
    procedure OnFinish(Sender : TObject);
    procedure OnClose(Sender : TObject);
    procedure Aggiungi(S : String);
    procedure SetCartella(const Value: String);
    procedure SetCaption(S : String);
    procedure SetCaptionVol(S : String);
    procedure SettaCaptionBraniPlay(S : String);
    procedure CambiaPosizione(I : Integer);
  public
    procedure Attiva;
    procedure Disattiva;
    function  NumberToTime(N : Integer; Separatore : Char): String;
    procedure CaricaPlayList(PercorsoLista: String);
    procedure CaricaSfondo(S : String);
    procedure CaricaImpostazioni;
    ///////////////////////////////////////////////
    ///////////////////////////////////////////////
    function  ControllaSeAttivo : Boolean;
    procedure AssegnaParent(Parent : TForm; Control : TWinControl);
    procedure AssegnaHint(Control : TWinControl; H : String);
    property CartellaPredefinita : String read PCartella write SetCartella;
    function Controlla(Ext : String) : Boolean;
  protected
    PlayList : TPlayList;
  end;

var
  MainForm: TMainForm;

const
  ExeName = 'Mp3Player';
  AppTit = 'Audio Player';
  AppIco = 'Immagini/Sound.ico';

implementation

uses UOpzioni ,ShellAPI ,UCaricaSalvaLista, UImpostazioni,
  UNuovaPlaylist, UAbout ,MMsystem;

{$R *.dfm}


procedure TMainForm.Aggiungi(S: String);
Var
   Nome : String;
begin
  Nome := ExtractFileName(S);
  if PlayList.Presente(S) then
      begin
       Lista.Items.Add(Nome);   
      end;
  if not PlayList.Playing then
   Play.Enabled := True;
end;

procedure TMainForm.AssegnaHint(Control: TWinControl; H: String);
begin
 Control.Hint := H;
end;

procedure TMainForm.AssegnaParent(Parent : TForm; Control : TWinControl);
begin
 Parent.Parent := Control;
end;

procedure TMainForm.Attiva;
begin
 Enabled := True;
end;

procedure TMainForm.CambiaPosizione(I: Integer);
begin
 PlayList.Play(I);
 Tempo := I div 1000;
end;

procedure TMainForm.CaricaImpostazioni;
Var
 Nome : String;
 Dati : TOpzioni;
begin
 Nome := OpzioniLavoro + '/Opzioni.dat';
 if LeggiFileOpzioni(Nome ,Dati) then
  begin
   CaricaPlayList(Dati.FileLista);
   CaricaSfondo(Dati.Sfondo);
  end;
end;



procedure TMainForm.CaricaPlayList(PercorsoLista: String);
Var
 Dati : TList;
 I    : Integer;
begin
 if PlayList.Opened then
  begin                    
   if PlayList.Stop then
    begin
     Pausa.Enabled := False;
     Stop.Enabled  := False;
     PLay.Enabled  := False;
     Resume := False;
     PlayList.Close;
     Caption := AppTit;
     TrayIcon1.Hint := AppTit;
     Timer1.Enabled := False;
     ProgressBar1.Position := 0;
    end;              
  end;
 if LeggiFileLista(PercorsoLista ,Dati) then
  begin
   LabelBrani.Caption := Dati.Nome;
   Image2.Picture.LoadFromFile(Dati.FileImmagine);
   Lista.Clear;
   PlayList.Clear;
   Image2.Hint := Dati.Nome;
   for I := 1 to Dati.Count - 1 do
    if not PlayList.Presente(Dati.Files[I]) then
      begin
       PlayList.Add(Dati.Files[I]);
       Aggiungi(PlayList.LastItem);
      end;
 end;
end;

procedure TMainForm.CaricaSfondo(S: String);
begin
 Image1.Picture.LoadFromFile(S);
end;

function TMainForm.Controlla(Ext: String): Boolean;
begin
  Result := False;
  if (Ext = '.wav') or (Ext = '.mp3') or (Ext = '.wmv') or (Ext = '.mid') or (Ext = '.cda') or (Ext = '.aac')then
    Result := True;
end;

function TMainForm.ControllaSeAttivo: Boolean;
Var
 NumeroIst : Integer;
begin
  Result := False;
  NumeroIst := 0;
  ProcessoAttivo(ExeName + '.exe' ,NumeroIst);
  if NumeroIst > 1 then
   Result := True;
end;

procedure TMainForm.Disattiva;
begin
 Enabled := False;
end;

procedure TMainForm.EkImgBtn1Click(Sender: TObject);
begin
 Close;
end;

procedure TMainForm.Esci1Click(Sender: TObject);
begin
 AboutForm.ShowModal;
end;

procedure TMainForm.Esci2Click(Sender: TObject);
begin
 PlaySound(PChar('SYSTEMQUESTION'), 0, SND_ASYNC);
 if MessageBox(MainForm.Handle ,'Sei sicuro di voler uscire?' ,'Uscire?' ,MB_ICONQUESTION or MB_YESNO) = ID_YES then
  Application.Terminate;      
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
Var
   I : Byte;
begin
 Action := caNone;
 for I := 255 downto 0 do
  begin
   AlphaBlendValue := I;
   Application.ProcessMessages;
   Sleep(2);
  end;
 Visible := False;
end;


procedure TMainForm.FormCreate(Sender: TObject);
Var
 I   : Integer;
 Arg : Integer;
 Str : String; 
begin
 if ControllaSeAttivo then
  begin

   Application.Terminate;
  end;
 dragAcceptFiles(Handle ,True );
 if not DirectoryExists(CartellaPlay) then
  CreateDir(CartellaPlay);
 PlayList := TPlayList.Create;
 PlayList.OnItemFinish := OnFinish;
 PlayList.OnClose := OnClose; 
 Down := False;
 Resume := False;
 Arg := Paramcount;
 if Arg > 0 then
  begin
    for I := 1 to Arg do
     begin
       Str := ParamStr(I);
       PlayList.Add(Str);
       Aggiungi(Str);
     end;
    Lista.ItemIndex := 0;
    PLayClick(Sender);
  end
 else
  CaricaImpostazioni;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
 if PlayList.Opened then
   PlayList.Close;
 PlayList.Free;
end;

procedure TMainForm.FormShow(Sender: TObject);
begin
 AlphaBlendValue := 255;
end;

procedure TMainForm.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 ReleaseCapture;
 Perform(WM_syscommand, $F012, 0);
end;

procedure TMainForm.LabelBraniMouseEnter(Sender: TObject);
begin
 LabelBrani.Font.Size := 12;
end;

procedure TMainForm.LabelBraniMouseLeave(Sender: TObject);
begin
 LabelBrani.Font.Size := 9;
end;

procedure TMainForm.Label3DblClick(Sender: TObject);
begin
 FormOpzioniPlaylist.Show;
 Disattiva;
end;

procedure TMainForm.Label3MouseEnter(Sender: TObject);
begin
 Label3.Font.Size := 12;
end;

procedure TMainForm.Label3MouseLeave(Sender: TObject);
begin
 Label3.Font.Size := 9;
end;

procedure TMainForm.ListaChange(Sender: TObject);
begin
 PLayClick(Sender);
 Hint := PlayList.Item[Lista.ItemIndex];
end;


procedure TMainForm.ListaClick(Sender: TObject);

begin


end;

//Il numero deve essere in millisecondi
function TMainForm.NumberToTime(N : Integer; Separatore : Char): String;
Var
 NTemp1,
 NTemp2,
 NTemp3 : Integer;
 Temp   : String;
begin
 NTemp1 := 0;
 NTemp2 := 0;
 NTemp3 := 0;
 Temp   := '';     
 NTemp1 := N div 1000; //ho tutti secondi
 if NTemp1 > 59 then
  begin
   NTemp2 := NTemp1 div 60; //ho i minuti netti ,ma potrebbero mancare secondi
   NTemp1 := NTemp1 mod 60; //che recupero qui
   if NTemp2 > 59 then
     NTemp3 := NTemp2 div 60; //ho le ore
     NTemp2 := NTemp2 mod 60; //recupero i minuti
  end;
 Temp := IntToStr(NTemp3);
 Temp := Temp + Separatore + IntToStr(NTemp2);
 Temp := Temp + Separatore + IntToStr(NTemp1);
 Result := Temp;
end;

procedure TMainForm.OnClose(Sender: TObject);
begin
 Pausa.Enabled := False;
 Stop.Enabled  := False;
 Play.Enabled  := True;
 Resume := False;
 Timer1.Enabled := False;
 ProgressBar1.Position := 0;
end;

procedure TMainForm.OnDroppedFiles(var Msg: TMessage);
const
   MAXCHARS = 254;
var
   hDroppedFile : THandle; // l'identificatore del nostro file
   bFilename   : Array[ 0..MAXCHARS ] of char;// il nome del file
   intNFiles   : Integer;
   intCounter  : Integer;
   FileName    : String;
   Name        : String;
begin
   FileName := '';
   hDroppedFile := Msg.wParam;
   intNFiles := dragQueryFile( hDroppedFile, uint(-1),
                               bFilename, MAXCHARS );
      for intCounter := ( intNFiles - 1 ) downto 0 do
      begin
         dragQueryFile( hDroppedFile, intCounter,
                        bFilename, MAXCHARS ); //bFileName  il percorso
         Name := bFilename;
      if Controlla(ExtractFileExt(Name)) then
       if not PlayList.Presente(Name) then
        begin
         PlayList.Add(Name);
         Aggiungi(Name);
        end;
      end;
   dragFinish( hDroppedFile );       
end;

procedure TMainForm.OnFinish(Sender: TObject);
begin
 Sleep(200);
 Timer1.Enabled := False;
 try
  if Lista.ItemIndex = PlayList.LungItems then
   begin
    Lista.ItemIndex := -1;
   end;
   Lista.ItemIndex := Lista.ItemIndex + 1;
   PLayClick(Sender);
 except
   Lista.ItemIndex := 0;
 end;
end;

procedure TMainForm.PausaClick(Sender: TObject);
begin
  if PlayList.Pause then
  begin
   Play.Enabled := True;
   Pausa.Enabled := False;
   Resume := True;           
   Timer1.Enabled := False;
  end; 
end;

procedure TMainForm.PlayClick(Sender: TObject);
Var
 Risposta : Boolean;
begin
  // da ricontrollare
  if PlayList.CurrItem <> PlayList.Item[Lista.ItemIndex] then
   begin
    try
     PlayList.CurrItem := PlayList.Item[Lista.ItemIndex];
     if PlayList.Playing then
      begin
       PlayList.Stop;
       PlayList.Close;
      end;
    except
     PlayList.CurrItem := PlayList.LastItem;
    end;
   end; 

  if not PlayList.Opened then
   if PlayList.Open then
    begin
     Tempo := 0;
     Minuti := 0;
  //   StringaLun:= IntToStr(Round(PlayList.Lunghezza / 1000));
     StringaLun := NumberToTime(Round(PlayList.Lunghezza) ,':');
     Label2.Caption := StringaLun;
     ProgressBar1.Position := 0;
     ProgressBar1.Max := PlayList.Lunghezza;
    end;

  if Resume then
   begin
    Risposta := PlayList.Resume;
    Resume := False;
   end
  else
   Risposta := PlayList.Play;

  if Risposta then     // quarto if
   begin
    PlayList.Volume := TrackBar1.Position;
    Play.Enabled := False;
    Pausa.Enabled := True;
    Stop.Enabled := True;
    SetCaption(AppTit + '   ' + PlayList.CurrName);
    TrayIcon1.Hint := AppTit + #13 + PlayList.CurrName ;
    Timer1.Enabled := True;
    if Down then
     begin
       PlayList.DisableSound;
     end;
   end;
end;

procedure TMainForm.Progressbar1Change(Sender: TObject);
begin
 if PlayList.Opened then
  begin
   Timer1.Enabled := False;
   CambiaPosizione(Progressbar1.Position);
   Timer1.Enabled := True;
  end;
end;

procedure TMainForm.rkGlassButton1Click(Sender: TObject);
begin
 Disattiva;
 FormOpzioni.Show;
end;

procedure TMainForm.SetCaption(S : String);
begin
 EkImgForm1.Caption := S;
end;

procedure TMainForm.SetCaptionVol(S: String);
begin
 TrackBar1.Hint := S;
end;

procedure TMainForm.SetCartella(const Value: String);
begin
 if DirectoryExists(Value) then
  begin
   PCartella := Value;
   OpenDialog1.InitialDir := PCartella;
   PlayListForm.SettaCartellaPred(PCartella);
  end;
end;


procedure TMainForm.SettaCaptionBraniPlay(S: String);
begin
 LabelBrani.Caption := S;
end;

procedure TMainForm.SpeedButton2Click(Sender: TObject);
Var
   I : Integer;
begin
 if OpenDialog1.Execute  then
   begin
    for I := 0 to OpenDialog1.Files.Count - 1 do
     begin
      if Controlla(ExtractFileExt(OpenDialog1.Files[I]))then
       if not PlayList.Presente(OpenDialog1.Files[I]) then
        begin
         PlayList.Add(OpenDialog1.Files[I]);
         Aggiungi(PlayList.LastItem); 
        end;
     end;
   end;         
end;

procedure TMainForm.StopClick(Sender: TObject);
begin
 if PlayList.Stop then  
  begin
   Pausa.Enabled := False;
   Stop.Enabled  := False;
   Play.Enabled  := True;
   Resume := False;
   PlayList.Close;
   SetCaption(AppTit);
   TrayIcon1.Hint := AppTit;
   Timer1.Enabled := False;
   ProgressBar1.Position := 0;
  end;    
end;

procedure TMainForm.Timer1Timer(Sender: TObject);
begin
 ProgressBar1.Position := PlayList.Posizione;
 Tempo := Tempo + 1;
 if Tempo >= 59 then
  begin
   Tempo := Tempo - 60;
   Minuti := Minuti + 1;
   if Minuti > 60 then
    begin
      Minuti := Minuti - 60;
      Ore := Ore + 1;
    end;
  end;
 if Tempo < 10 then  
  Label2.Caption := IntToStr(Ore) + ':' + IntToStr(Minuti) + ':' + '0' + IntToStr(Tempo) + ' / ' + StringaLun
 else
  Label2.Caption := IntToStr(Ore) + ':' + IntToStr(Minuti) + ':' + IntToStr(Tempo) + ' / ' + StringaLun;
end;

procedure TMainForm.TrackBar1Change(Sender: TObject);
begin
 if PlayList.LungItems >= 0 then
   begin
    PlayList.Volume := TrackBar1.Position;
    SetCaptionVol(IntToStr(TrackBar1.Position div 10) + '%');
    Sleep(50);
   end;
end;

procedure TMainForm.TrackBar1MouseLeave(Sender: TObject);
begin
 SetCaptionVol('Volume');
end;

procedure TMainForm.TrayIcon1DblClick(Sender: TObject);
begin
 Visible := True;
end;

procedure TMainForm.VolClick(Sender: TObject);
Var
 B : TBitmap;
begin
 B := Nil;
 try
  B := TBitmap.Create;
  if not Down then
   begin
    B.LoadFromFile('Immagini\VolumeDisabled.bmp');
    Down := True;
    PlayList.DisableSound;
   end
  else
   begin
    B.LoadFromFile('Immagini\Volume Normal.bmp');
    PlayList.EnableSound;
    Down := False;
   end;
  Vol.ImageIconBmp := B;
 finally
  B.Free;
 end;       

end;


end.
