unit UImpostazioni;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls,ExtDlgs;

type
  TFormOpzioni = class(TForm)
    LabeledEdit1: TLabeledEdit;
    GroupBox1: TGroupBox;
    SfondoPlayer: TLabeledEdit;
    GroupBox2: TGroupBox;
    OpenPictureDialog1: TOpenPictureDialog;
    Button1: TButton;
    CheckBox1: TCheckBox;
    ListBox1: TListBox;
    procedure LabeledEdit1DblClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SfondoPlayerDblClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    Dir : String;
    Lista ,Perscorsi : TStringList;
    function CartellaLav : String;
    function Sfondo : String;
    function FileLista : String;
    procedure ElencaPlayLists(List : TListBox);
  public
    procedure SelCartella;
    procedure SettaTestoCartella(S : String);
  end;

var
  FormOpzioni: TFormOpzioni;

const
 OpzioniLavoro = 'Opzioni';

implementation

uses
 MainMp3, UOpzioni, UCaricaPlayList;

{$R *.dfm}

procedure TFormOpzioni.Button1Click(Sender: TObject);
Var
 Action : TCloseAction;
 Dati : TOpzioni;
 S : String;
begin
 Dati.Cartella := CartellaLav;
 S := Sfondo;
 Dati.Sfondo := S;
 Dati.FileLista := FileLista;
 if NuovoFileOpzioni(OpzioniLavoro + '\Opzioni.dat' ,Dati) then
  begin
   if FileExists(S) then
    begin
      MainForm.CaricaSfondo(S);
      MainForm.CaricaImpostazioni;
    end;
  end;
 FormClose(Sender ,Action);
end;


function TFormOpzioni.CartellaLav: String;
begin
 Result := LabeledEdit1.Text;
end;

procedure TFormOpzioni.ElencaPlayLists(List: TListBox);
begin
  Lista.Clear;
  if DirectoryExists(CartellaPlay) then
   begin
    CercaFilesCercaFilesConINomiSenzaEst(Lista ,CartellaPlay ,'*.dat');
    CercaFiles(Perscorsi ,CartellaPlay ,'*.dat');
    List.Items.Assign(Lista);
   end;
end;

function TFormOpzioni.FileLista: String;
begin
 Result := '';
 if ListBox1.ItemIndex <> -1 then
  Result := Perscorsi.Strings[ListBox1.ItemIndex];
end;

procedure TFormOpzioni.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 Action := caNone;
 Hide;
 MainForm.Attiva;
end;

procedure TFormOpzioni.FormCreate(Sender: TObject);
begin
 Lista := TStringList.Create;
 Perscorsi := TStringList.Create;
end;

procedure TFormOpzioni.FormDestroy(Sender: TObject);
begin
 Lista.Free;
end;

procedure TFormOpzioni.FormShow(Sender: TObject);
begin
 if not DirectoryExists(OpzioniLavoro) then
   CreateDir(OpzioniLavoro);
 ElencaPlayLists(ListBox1);
end;

procedure TFormOpzioni.LabeledEdit1DblClick(Sender: TObject);
begin
 SelCartella;
 LabeledEdit1.Text := Dir;
end;

procedure TFormOpzioni.SelCartella;
begin
 SelezionaCartella(Handle ,Dir,'','Scegli la tua cartella  principale');
end;

procedure TFormOpzioni.SettaTestoCartella(S: String);
begin
 LabeledEdit1.Text := S;
end;

function TFormOpzioni.Sfondo: String;
begin
 Result := SfondoPlayer.Text;
end;

procedure TFormOpzioni.SfondoPlayerDblClick(Sender: TObject);
begin
 if OpenPictureDialog1.Execute then
  begin
    SfondoPlayer.Text := OpenPictureDialog1.FileName;
  end;
end;

end.
