unit UNuovaPlaylist;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ExtDlgs;

type
  TPlayListForm = class(TForm)
    ENome: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Button1: TButton;
    Button2: TButton;
    OpenDialog1: TOpenDialog;
    ListBox1: TListBox;
    CheckBox1: TCheckBox;
    Image1: TImage;
    OpenPictureDialog1: TOpenPictureDialog;
    procedure Label2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ENomeKeyPress(Sender: TObject; var Key: Char);
    procedure Image1DblClick(Sender: TObject);
    procedure ListBox1KeyPress(Sender: TObject; var Key: Char);
    procedure FormCreate(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    NomeImmagine : String;
  public
    procedure SettaCartellaPred(Cartella : String);
  end;

var
  PlayListForm: TPlayListForm;

implementation

uses UOpzioni, MainMp3, UCaricaPlayList;

{$R *.dfm}

procedure TPlayListForm.Button1Click(Sender: TObject);
begin
 if MessageBox(Handle ,'Sei sicuro di voler annullare la procedura?' ,'Annullare?' ,MB_ICONQUESTION or MB_YESNO ) = ID_YES then
  begin
   ListBox1.Clear;
   ENome.Clear;
   Hide;
   MainForm.Attiva;
  end;
end;

procedure TPlayListForm.Button2Click(Sender: TObject);
Var
 Lista : TList;
 Count,
 I     : Integer;
begin
 if ENome.Text <> '' then
  begin
  Count := ListBox1.Items.Count;
  //migliorare questa parte
  if Count > 100 then
   begin
    MessageBox(Handle ,'Ogni playlist pu contenere al massimo 100 elementi','Errore' , MB_ICONERROR);
    Exit;
   end;
   if (Count > 0) then
    begin
     Lista.Nome := ENome.Text;
     FillChar(Lista.Files ,Sizeof(Lista.Files) ,#0);
     for I := 1 to Count - 1 do
      begin
        Lista.Files[I] := ListBox1.Items[I];
      end;
     Lista.Count := I;
     Lista.FileImmagine := NomeImmagine;
     if NuovoFileLista(CartellaPlay + '\' + ENome.Text + '.dat' ,Lista) then
      begin
       Hide;
       MainForm.Attiva;
       FormCarica.ElencaPlayList(FormCarica.ListBox1);
      end
     else
      MessageBox(Handle ,'Sembra che la playlist esista o non si dispone dei permessi necessari per crearne una','Errore' , MB_ICONERROR);
    end
  else
   MessageBox(Handle ,'Lista vuota!' + #13 + 'Selezionare i files della nuova playlist','Errore' , MB_ICONERROR);
  end
 else
  MessageBox(Handle ,'Inserire il nome della playlist','Errore' , MB_ICONERROR);
end;

procedure TPlayListForm.ENomeKeyPress(Sender: TObject; var Key: Char);
begin
 if Key = #13 then
  begin
    Key := #0;
    Button2Click(Sender);
  end;
end;

procedure TPlayListForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 Action := caNone;
 Image1.Picture.LoadFromFile(AppIco);
 Button1Click(Sender);
end;

procedure TPlayListForm.FormCreate(Sender: TObject);
begin
 NomeImmagine := AppIco;
end;

procedure TPlayListForm.FormKeyPress(Sender: TObject; var Key: Char);
begin
 if Ord(Key) = 27 then
  Button1Click(Sender);
end;

procedure TPlayListForm.Image1DblClick(Sender: TObject);
begin
 if OpenPictureDialog1.Execute then
  begin
    NomeImmagine := OpenPictureDialog1.FileName;
    Image1.Picture.LoadFromFile(OpenPictureDialog1.FileName);
  end;
end;

procedure TPlayListForm.Label2Click(Sender: TObject);
Var
 I : Integer;
begin
 if OpenDialog1.Execute then
  begin
    for I := 0 to OpenDialog1.Files.Count - 1 do
      begin
        ListBox1.Items.Add(OpenDialog1.Files[I]);
      end;
  end;
end;

procedure TPlayListForm.ListBox1KeyPress(Sender: TObject; var Key: Char);
begin
  if (Ord(Key) = 67) or (Ord(Key) = 99)then
   ListBox1.DeleteSelected;
  FormKeyPress(Sender ,Key);
end;

procedure TPlayListForm.SettaCartellaPred(Cartella: String);
begin
 OpenDialog1.InitialDir := Cartella;
end;

end.
