unit UOpzioni;

interface

uses
  Graphics ,Classes ,Windows;


const
 CartellaPlay = 'PlayLists';

type

 TOpzioni = record
   Cartella : String[255];
   Sfondo : String[255];
   FileLista : String[255];
 end;

 TList = record
   Nome  : String[255];
   Files : array [1..100] of String[255];
   Count : Integer;
   FileImmagine : String[255];
 end;

 TMaxChar = array [0..MAX_PATH] of Char;

 TFileList = file of TList;

 TFileOpzioni = file of TOpzioni;

function NuovoFileLista(Nome : String; Dati : TList) : Boolean;

function NuovoFileOpzioni(Nome : String; Dati : TOpzioni) : Boolean;

function CancellaFile(Nome : String) : Boolean;

function AggiornaFileLista(Nome : String; Dati : TList) : Boolean;

function LeggiFileLista(Nome : String; var Dati : TList) : Boolean;

function LeggiFileOpzioni(Nome : String; var Dati : TOpzioni) : Boolean;

{-----------------------------------------------------------------}

function SelezionaCartella(H : HWND; var Dir : String;const InitDir : String = '';  Informazioni : String = ''; NewCartella : Boolean = True) : Boolean;

procedure CercaFiles(FilesList: TStringList; StartDir, FileMask: string);

procedure CercaFilesCercaFilesConINomiSenzaEst(FilesList: TStringList; StartDir, FileMask: string);

procedure CercaFilesConINomiEstratti(FilesList: TStringList; StartDir, FileMask: string);

procedure SettaAppPred(NomeApp : String; Ext : String);

function ProcessoAttivo(Nome : String) : Boolean; overload;

function ProcessoAttivo(Nome : String; var NumeroIstanze : Integer) : Boolean; overload;

implementation

uses
 SysUtils ,ShlObj ,Registry ,TlHelp32 ,PsAPI;

function NuovoFileLista(Nome : String; Dati : TList) : Boolean;
Var
 F : TFileList;
begin
  if FileExists(Nome) then
   Result := False
  else
   begin
     AssignFile(F ,Nome);
     try
     {$I-}
       Rewrite(F);
     {$I+}
       if IOResult <> 0 then
         Result := False
       else
        begin
          write(F ,Dati);
          Result := True;
        end;
     finally
       CloseFile(F);
     end;
   end;
end;

function NuovoFileOpzioni(Nome : String; Dati : TOpzioni) : Boolean;
Var
 F : TFileOpzioni;
begin
  if FileExists(Nome) then
   Result := False
  else
   begin
     AssignFile(F ,Nome);
     try
     {$I-}
       Rewrite(F);
     {$I+}
       if IOResult <> 0 then
         Result := False
       else
        begin
          write(F ,Dati);
          Result := True;
        end;
     finally
       CloseFile(F);
     end;
   end;
end;

function CancellaFile(Nome : String) : Boolean;
Var
 F : File;
begin
   if not FileExists(Nome) then
   Result := False
  else
   begin
     AssignFile(F ,Nome);
     try
     {$I-}
       Rewrite(F);
     {$I+}
       if IOResult <> 0 then
         Result := False
       else
        begin
          Erase(F);
          Result := True;
        end;
     finally
       CloseFile(F);
     end;
   end;
end;

function AggiornaFileLista(Nome : String; Dati : TList) : Boolean;
Var
 F : TFileList;
begin
  if not FileExists(Nome) then
   Result := False
  else
   begin
     AssignFile(F ,Nome);
     try
     {$I-}
       Reset(F);
     {$I+}
       if IOResult <> 0 then
         Result := False
       else
        begin
          write(F ,Dati);
          Result := True;
        end;
     finally
       CloseFile(F);
     end;
   end;
end;

function LeggiFileLista(Nome : String; var Dati : TList) : Boolean;
Var
 F : TFileList;
begin
  if not FileExists(Nome) then
   Result := False
  else
   begin
     AssignFile(F ,Nome);
     try
     {$I-}
       Reset(F);
     {$I+}
       if IOResult <> 0 then
         Result := False
       else
        begin
          Read(F ,Dati);
          Result := True;
        end;
     finally
       CloseFile(F);
     end;
   end;
end;

function LeggiFileOpzioni(Nome : String; var Dati : TOpzioni) : Boolean;
Var
 F : TFileOpzioni;
begin
  if not FileExists(Nome) then
   Result := False
  else
   begin
     AssignFile(F ,Nome);
     try
     {$I-}
       Reset(F);
     {$I+}
       if IOResult <> 0 then
         Result := False
       else
        begin
          Read(F ,Dati);
          Result := True;
        end;
     finally
       CloseFile(F);
     end;
   end;

end;

{-----------------------------------------------------------------}

var
 StartFold : String;
 
function BrowseCallBack(Wnd : HWND; uMsg : UINT; lParam ,lpData: LPARAM): Integer stdcall;
begin
  if uMsg = BFFM_INITIALIZED then
    SendMessage(Wnd,BFFM_SETSELECTION, 1, Integer(@StartFold[1]));
  Result := 0;
end;


function SelezionaCartella(H : HWND; var Dir : String;const InitDir : String = '';  Informazioni : String = ''; NewCartella : Boolean = True) : Boolean;
Var
 B : _browseinfoA;
 Ris : PItemIDList;
 Tit : TMaxChar;
begin
  StartFold := InitDir;
  FillChar(B,SizeOf(B),#0);
  B.hwndOwner := H;
  B.pszDisplayName := @Tit[0];
  B.lpszTitle := PAnsiChar(Informazioni);
  B.ulFlags := BIF_NEWDIALOGSTYLE  or BIF_RETURNONLYFSDIRS;
  if not NewCartella then
   B.ulFlags :=  B.ulFlags or BIF_NONEWFOLDERBUTTON;
  B.lpfn := BrowseCallBack;
  Ris := SHBrowseForFolder(B);
  Result := False;
  if Ris <> Nil then
   begin
     if SHGetPathFromIDList(Ris ,Tit)  then
      begin
       Dir := Tit;
       GlobalFreePtr(Ris);
       Result := True;
      end;
   end;
end;

procedure CercaFiles(FilesList: TStringList; StartDir, FileMask: string);
var
  SR: TSearchRec;
  DirList: TStringList;
  IsFound: Boolean;
  i: integer;
begin
  if StartDir[length(StartDir)] <> '\' then
    StartDir := StartDir + '\';

  { Build a list of the files in directory StartDir
     (not the directories!)                         }

  IsFound :=
    FindFirst(StartDir+FileMask, faAnyFile-faDirectory, SR) = 0;
  while IsFound do begin
    FilesList.Add(StartDir + SR.Name);
    IsFound := FindNext(SR) = 0;
  end;
  FindClose(SR);

  // Build a list of subdirectories
  DirList := TStringList.Create;
  IsFound := FindFirst(StartDir+'*.*', faAnyFile, SR) = 0;
  while IsFound do begin
    if ((SR.Attr and faDirectory) <> 0) and
         (SR.Name[1] <> '.') then
      DirList.Add(StartDir + SR.Name);
    IsFound := FindNext(SR) = 0;
  end;
  FindClose(SR);

  // Scan the list of subdirectories
  for i := 0 to DirList.Count - 1 do
    CercaFiles(FilesList, DirList[i], FileMask);

  DirList.Free;
end;

procedure CercaFilesCercaFilesConINomiSenzaEst(FilesList: TStringList; StartDir, FileMask: string);
var
  SR: TSearchRec;
  DirList: TStringList;
  IsFound: Boolean;
  i: integer;
  S ,
  TempString : String;
begin
  if StartDir[length(StartDir)] <> '\' then
    StartDir := StartDir + '\';

  { Build a list of the files in directory StartDir
     (not the directories!)                         }

  IsFound :=
    FindFirst(StartDir+FileMask, faAnyFile-faDirectory, SR) = 0;
  while IsFound do begin
    TempString := ExtractFileName(StartDir + SR.Name);
    S := ExtractFileExt(TempString);
    Delete(TempString ,Pos(S ,TempString) ,Length(S));
    FilesList.Add(TempString);
    IsFound := FindNext(SR) = 0;
  end;
  FindClose(SR);

  // Build a list of subdirectories
  DirList := TStringList.Create;
  IsFound := FindFirst(StartDir+'*.*', faAnyFile, SR) = 0;
  while IsFound do begin
    if ((SR.Attr and faDirectory) <> 0) and
         (SR.Name[1] <> '.') then
      DirList.Add(StartDir + SR.Name);
    IsFound := FindNext(SR) = 0;
  end;
  FindClose(SR);

  // Scan the list of subdirectories
  for i := 0 to DirList.Count - 1 do
    CercaFiles(FilesList, DirList[i], FileMask);

  DirList.Free;

end;

procedure CercaFilesConINomiEstratti(FilesList: TStringList; StartDir, FileMask: string);
var
  SR: TSearchRec;
  DirList: TStringList;
  IsFound: Boolean;
  i: integer;
begin
  if StartDir[length(StartDir)] <> '\' then
    StartDir := StartDir + '\';

  { Build a list of the files in directory StartDir
     (not the directories!)                         }

  IsFound :=
    FindFirst(StartDir+FileMask, faAnyFile-faDirectory, SR) = 0;
  while IsFound do begin
    FilesList.Add(ExtractFileName(StartDir + SR.Name));
    IsFound := FindNext(SR) = 0;
  end;
  FindClose(SR);

  // Build a list of subdirectories
  DirList := TStringList.Create;
  IsFound := FindFirst(StartDir+'*.*', faAnyFile, SR) = 0;
  while IsFound do begin
    if ((SR.Attr and faDirectory) <> 0) and
         (SR.Name[1] <> '.') then
      DirList.Add(StartDir + SR.Name);
    IsFound := FindNext(SR) = 0;
  end;
  FindClose(SR);

  // Scan the list of subdirectories
  for i := 0 to DirList.Count - 1 do
    CercaFiles(FilesList, DirList[i], FileMask);

  DirList.Free;
end;

procedure SettaAppPred(NomeApp : String; Ext : String);
Var
 Reg : TRegistry;
begin
 try
   Reg := TRegistry.Create;
   Reg.RootKey := HKEY_CLASSES_ROOT;
 finally
   Reg.Free;
 end;
end;

function ProcessoAttivo(Nome : String) : Boolean; overload;
Var
 HSnap    : THANDLE;
 PrcInf   : tagPROCESSENTRY32;
 S : String;
begin
 Result := False;
 PrcInf.dwSize := Sizeof(PROCESSENTRY32);
 HSnap := CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS ,0);
 while  Process32Next(HSnap ,PrcInf) do
    begin
     S := StrPas(PrcInf.szExeFile);
     if S = Nome then
      begin
       Result := True;
       Break;
      end;
    end;
 CloseHandle(HSnap);;
end;

function ProcessoAttivo(Nome : String; var NumeroIstanze : Integer) : Boolean;
Var
 HSnap    : THANDLE;
 PrcInf   : tagPROCESSENTRY32;
 S        : String;
begin
 Result := False;
 PrcInf.dwSize := Sizeof(PROCESSENTRY32);
 HSnap := CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS ,0);
 NumeroIstanze := 0;
 while  Process32Next(HSnap ,PrcInf) do
    begin
     S := StrPas(PrcInf.szExeFile);
     if S = Nome then
      begin
       NumeroIstanze := NumeroIstanze + 1;
       Result := True;
      end;
    end;
 CloseHandle(HSnap);
end;

end.
